Bug Hunting Session
Bug 90180 - FORMATTING feature request: error bars style => error box
Summary: FORMATTING feature request: error bars style => error box
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Chart (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: Other All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard: target:6.3.0
Keywords: needsUXEval
Depends on:
Blocks: Chart-Enhancements
  Show dependency treegraph
 
Reported: 2015-03-24 00:40 UTC by bruno.binet
Modified: 2019-11-12 06:42 UTC (History)
10 users (show)

See Also:
Crash report or crash signature:


Attachments
simple example of error rectangles in a chart (23.53 KB, image/png)
2019-01-21 16:47 UTC, Winfried Donkers (retired)
Details
Mockup with maximum flexibility (182.58 KB, image/png)
2019-10-14 12:32 UTC, Heiko Tietze
Details

Note You need to log in before you can comment on or make changes to this bug.
Description bruno.binet 2015-03-24 00:40:08 UTC
For science charts, it would be nice to have another style for error bars. Instead of the actual bars (centered on the points), we could have rectangular boxes. For example, if X and Y values have errors of ±0.5 and ±3 respectively, each point would be surrounded by a "1 unit X 6 units" box. 

With this feature, Calc would have an edge on Excel for science charts. The actual errors bars could be the default style for compatibility or when saving to XLS.
Comment 1 Robinson Tryon (qubit) 2015-03-29 16:04:51 UTC
(In reply to bruno.binet from comment #0)
> For science charts, it would be nice to have another style for error bars.
> Instead of the actual bars (centered on the points), we could have
> rectangular boxes. For example, if X and Y values have errors of ±0.5 and ±3
> respectively, each point would be surrounded by a "1 unit X 6 units" box. 
> 
> With this feature, Calc would have an edge on Excel for science charts. The
> actual errors bars could be the default style for compatibility or when
> saving to XLS.

Sounds like a nice idea for better data visualization:
Status -> NEW

I'm not sure if there'd need to be any extension to the ODF format to support this style... cc'ing Winfried for input.
Comment 2 Winfried Donkers (retired) 2015-03-30 06:19:04 UTC
(In reply to Robinson Tryon (qubit) from comment #1)
> I'm not sure if there'd need to be any extension to the ODF format to
> support this style... cc'ing Winfried for input.

Neither do I know, I'm not acquainted with charts (I try to focus on Calc functions). Anyway, IFAIK any application can add specific (application-dependent) information to the ODF format.

I agree it is a welcome enhancement.

CC-ing Eric Seynaeve, who did an interesting chart enhancement some time ago.
Comment 3 bruno.binet 2016-06-07 19:29:56 UTC
Again, it would be a nice enhancement
Comment 4 eckold 2017-02-19 13:01:34 UTC
More options to format the error bars are greatly needed.
Comment 5 bruno.binet 2017-03-08 01:14:01 UTC
We are still very interested by this feature.

When the error bars are small, the actual tick marks (at the bar's end) may lead to confusion.
Comment 6 Winfried Donkers (retired) 2017-03-08 09:37:16 UTC
The LibreOffice code is for a large part maintained by volunteers.

If you need a certain enhancement/bug fix there is always the possibility to have a specialised company/certified developer do that (see https://www.documentfoundation.org/gethelp/developers/). 
You'll have to pay for that naturally.
Comment 7 bruno.binet 2017-03-08 15:33:41 UTC
(In reply to Winfried Donkers from comment #6)
> If you need a certain enhancement/bug fix there is always the possibility to
> have a specialised company/certified developer do that (see
> https://www.documentfoundation.org/gethelp/developers/). 
> You'll have to pay for that naturally.

Since you are suggesting to pay a certified developer to get this enhancement, are you interested? Or is there any other developers experimented with the chart module? If I know the amount, I could check if my department can afford it. If reasonable, I suppose it would be possible.
Comment 8 Winfried Donkers (retired) 2019-01-21 16:47:11 UTC
Created attachment 148487 [details]
simple example of error rectangles in a chart

This example shows what I am working on. The X- and Y-error bar dialogs are the same for cross and rectangle. A global configuration setting will make whether crosses or rectangles are used in charts with error-presentation.
Comment 9 Commit Notification 2019-05-20 10:59:04 UTC
Winfried Donkers committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/f6f27ae31a26bf6cecbf9205ef28a6bad3d06864%5E%21

tdf#90180 Add option to show errors as rectangles in diagrams with error bars.

It will be available in 6.3.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 10 Xisco Faulí 2019-06-26 10:28:27 UTC
A polite ping to Winfried Donkers:
Is this bug fixed? if so, could you please close it as RESOLVED FIXED ? Otherwise, Could you please explain what's missing?
Thanks
Comment 11 Winfried Donkers (retired) 2019-06-26 10:59:31 UTC
(In reply to Xisco Faulí from comment #10)
> A polite ping to Winfried Donkers:
> Is this bug fixed? if so, could you please close it as RESOLVED FIXED ?
> Otherwise, Could you please explain what's missing?
> Thanks

This enhancement is not fully fixed yet. The basic functionality will be present in version 6.3 and together with user experience from version 6.3 a fitting UI solution for the settings will have to be made.
When that has been done, I will close this bug report.
Comment 12 bruno.binet 2019-08-26 16:04:32 UTC
First thank you very much Winfried for this new feature in 6.3. I tried it and it is exactly what I asked.

As Windried said, the UI should be improved for the settings. Right now, one has to reach the advanced options, click on the 'Expert Configuration' button and search for 'ErrorRectangle' to switch the setting. But it works! 

The simplest thing to do is to move this setting in the normal chart options. In the short therm, it would be acceptable.

Of course, it would be more logical to combine the error-rectangles setting with the error-bar settings. In fact, both X and Y error bar dialogs should be combined in one dialog with tabs. The error rectangle setting could be on a distinct tab (maybe with line settings with the option to have the same line settings for both axis) or duplicated on both X and Y tabs. Actually, the "line" tab is not accessible in the (first) error bar "creation" step. As a bonus, it would be an enhancement to have all the error bars settings in a single step (creation for X and Y, line settings + error rectangle setting).

Maybe, for some type of charts, some options should be inactivated (in grey). For example, no X error bar (so no error rectangle setting) for an histogram (column bar graph). Alternatively, we could only apply the new dialog for X-Y graphs (no brainer), so users of other types would not be affected by unwanted regressions.
Comment 13 Winfried Donkers (retired) 2019-08-27 05:42:14 UTC
(In reply to bruno.binet from comment #12)

I am thinking about the following addittions to make this feature complete:
1. save the error cross/rectangle settings for each chart in the document;
2. combine the separate X- and Y-errorbar settings dialog to one error settings dialog with tabs: general (where the cross/error choice can be set), X- and Y-error bar settings.

It seems to me that you are thinking along the same line.
Comment 14 Winfried Donkers (retired) 2019-10-11 09:22:27 UTC
Health forces me to quit finishing this enhancement.
I hope that Heiko will complete the task or find someone who will.
Comment 15 Heiko Tietze 2019-10-11 12:00:37 UTC
So we talk about the functions in the context menu Error Bar X/Y available when switched on via expert settings. Not really clear what X deviation would be but whiskers are definitely needed for statistics. Nice topic for the UX people...
Comment 16 bruno.binet 2019-10-11 14:31:04 UTC
Of course, traditional Y-only error bars are still needed in other contexts. The combined settings dialog proposed by Winfried and me could handle these cases. In the "general" tab, the user will not choose the "rectangle" option, but "bar / whiskers" (it could be the default) and of course no need to visit the X error tab in this case (they will have a value of 0, so no X error bars). 

The chart menu should be modified also with only one option to insert error bars (not one for X and another for Y) that would call the combined dialog.
Comment 17 Heiko Tietze 2019-10-14 12:32:25 UTC
Created attachment 154993 [details]
Mockup with maximum flexibility

Here is a mockup how I would like to create box-whisker plots. It has some flexibility but probably cannot be implemented as it due to the completely different approach.
Comment 18 bruno.binet 2019-10-14 14:31:04 UTC
(In reply to Heiko Tietze from comment #17)
> Created attachment 154993 [details]
> Mockup with maximum flexibility
> 
> Here is a mockup how I would like to create box-whisker plots. It has some
> flexibility but probably cannot be implemented as it due to the completely
> different approach.

Well, "box and whiskers plots" present 5 values (on the same axis) instead of 3 for a classic error bar (often 2 when + and - are the same). So this is beyond the actual feature request. Also, the width of the rectangle here has no signification. It's interesting, but I don't think we should see the error rectangles (or bars) as a particular case of "box and whiskers plots". Maybe we could switch from one to another in the "general" tab of the combined settings dialog proposed by Winfried and me.

If the user chooses error bars or error rectangles, the dialog would have the simpler X and Y error tabs. These tabs would be replaced by a more complex "box and whiskers" tab (your mockup in fact) if the user chooses this in the general tab. Best of both worlds?
Comment 19 Heiko Tietze 2019-11-08 10:38:22 UTC
The supposed workflow, as I understand, is to create a bar chart and add error bars (actually whiskers) later. The whisker can have a constant value, a relative to Y, and a range. Something like:

Mean	SD
8,42	0,96
1,79	0,98
6,01	0,35

with chart range = A2:A4 and error range = B2:B4

What I don't understand is how the statistics (standard deviation, error, variance...) should be calculated (and if it's really needed). So what's needed for a MVP?
Comment 20 bruno.binet 2019-11-08 13:27:17 UTC
(In reply to Heiko Tietze from comment #19)
> The supposed workflow, as I understand, is to create a bar chart and add
> error bars (actually whiskers) later. The whisker can have a constant value,
> a relative to Y, and a range. Something like:
> 
> Mean	SD
> 8,42	0,96
> 1,79	0,98
> 6,01	0,35
> 
> with chart range = A2:A4 and error range = B2:B4
> 
> What I don't understand is how the statistics (standard deviation, error,
> variance...) should be calculated (and if it's really needed). So what's
> needed for a MVP?

Just to be clear: this enhancement was proposed for XY charts. The "box and whiskers plots" might be added in the same time (or not, I don't know). 

I'm not a statistics specialist. However, as I understand it, nothing has to be calculated since the user will (in the most general case) provide all the values (cells) required for "box and whiskers plots".
Comment 21 Heiko Tietze 2019-11-11 13:23:19 UTC
So it's fixed? Except documentation. And shall we remove the deviation option?
Comment 22 bruno.binet 2019-11-11 14:32:31 UTC
(In reply to Heiko Tietze from comment #21)
> So it's fixed? Except documentation. And shall we remove the deviation
> option?

Please read comments 11-12-13 for an answer to this question. Even in the simplest form, the UI should to me modified.
Comment 23 QA Administrators 2019-11-12 03:34:17 UTC Comment hidden (obsolete)
Comment 24 Winfried Donkers (retired) 2019-11-12 06:42:06 UTC
This is an evaluated enhancement request, of which one part has been realised. The remaining parts (UI, save setting in document, documentation) are yet to be accomplished. I am no longer able to do this, so I switched status from ASIGNED back to NEW and Heiko Tietze is currently busy with the possible UI solutions.